Scrum - Defect #3816

Drag and drop does not work correctly on the Scrum board
2014-06-13 19:47 - Mike Sanders

Status: Rejected

Priority: High

Category: Sprint board

Target version:

Source: Development Blocked: No
Detected on version: Scrum v0.5.0 Alone:

Description

1. Login to Redmine as a user that has permission to re-organize the scrumboard
2. Go to the Scrum section

3. Go to the Scrumboard

4. Attempt to drag and drop an item

5. Notice items will not move

History

#1 - 2014-07-03 18:59 - Emilio Gonzalez Montaina

Please provide a screenshot of your Scrum plugin settings. Most of the times there is an error there.

#2 - 2014-07-03 19:01 - Emilio Gonzalez Montaina
- Sprint set to Product backlog

#3 - 2014-07-17 00:03 - Danny Gorton
- File Screenshot from redmine1.png added

- File Screenshot from redmine2.png added

| have the same issue. | thought it might be permissions, but | can move backlog items up and down. | attached two screenshots of my Scrum plugin
settings page.

#4 - 2014-07-23 08:05 - Danny Gorton

Do you see an error in my plugin settings? Do you have any thoughts on how | might go about figuring out this problem? Is there something | might
look for in a log, or maybe a web debugger? I'd like to plan some sprints but it's impossible if | can't move any tasks from the backlog status.

#5 - 2014-07-23 10:03 - Danny Gorton

- File redmine developer role 1.png added
- File redmine developer role 2.png added
- File redmine project roles.png added

| figured out how to view the client-side sources for a plugin and was able to determine a few things. The main things are:

1) the post-its on the sprint board aren't decorated with the .post-it-horizontal-move-cursor CSS class, so the cursor is just normal, while on the
project backlog board the items have the .post-it-vertical-move-cursor class.

2) the draggableOnTouchScreen method is not called for post-its on the sprint board, but it is for those on the project backlog board
3) in fact, the draggableOnTouchScreen isn't ‘'wired up' for the sprint board post-its. That implied a server-side rendering problem.
So | did a grep for draggableOnTouchScreen and found ./app/views/post_its/sprint_board/_task.js.erb contains this logic

if User.current.allowed_to?(:edit_sprint_board, project) and task.editable?

and ./app/views/post_its/product_backlog/_pbi.html.erb contains this logic

if User.current.allowed_to?(:edit_product_backlog, project) and pbi.editable?

Those bits of code indicate that it does indeed seem to be a permissions issue. So looking at my permissions, | was in 3 roles and two of those roles
have zero Scrum permissions and the other role has all Scrum permissions. So | removed myself from the roles with no permissions and that had no
effect. So | gave all roles all permissions and that had no effect. So now I'm wondering what the problem might be. There is another condition in that
check that I'm not sure how to check: task.editable? It could be that my permissions are OK, but the task isn't editable. What makes a task NOT
editable? I've attached three more screen shots showing my roles and permissions settings.

#6 - 2014-07-23 13:34 - Michael Kimsal

1. Returns true if user or current user is allowed to edit or add a note to the issue
def editable?(user=User.current)
user.allowed_to?(:edit_issues, project) || user.allowed_to?(:add_issue_notes, project)
end

If the user can edit issues and add issue notes, the issue is "editable".

Doesn't really help me, as | have those permissions, and still can't move items on the sprint board. :/

#7 - 2014-07-24 14:29 - Michael Kimsal

in /plugins/scrum/app/views/post_its/sprint_board/_pbi_status.js.erb
change the 'accept' indicating ".sprint-task" to ".sprint-pbi"

The task cards are not being decorated properly, | guess. This worked for me on the 0.7.0 version. There's no public code repo for the project that |
know of, so | can't submit a patch. :(

#8 - 2014-07-24 17:24 - Danny Gorton

Michael Kimsal escribio:
in /plugins/scrum/app/views/post_its/sprint_board/_pbi_status.js.erb
change the 'accept' indicating ".sprint-task" to ".sprint-pbi"

The task cards are not being decorated properly, | guess. This worked for me on the 0.7.0 version. There's no public code repo for the project
that | know of, so | can't submit a patch. :(

Interesting, | see where that change matches one of the CSS classes my tasks are decorated with, so it makes sense but it doesn't solve my problem.
Before you fixed it, were you able to initiate the drag, but not able to drop the task? | can't initiate the drag.

#9 - 2014-07-26 10:28 - Danny Gorton

Well, something's weird here. | upgraded to version 0.7.0 and applied the patch that Michael Kimsal supplied but | still couldn't initiate a drag
operation on the sprint board. Digging through the code, | couldn't see where the 'draggableOnTouchScreen' logic was being applied to items in my
PBI list at all. So | hacked in some javascript from the _tasks.js.erb and retried. Now | can at least initiate a drag from the PBI list. It fails to persist
the status update and | can't move it back to the PBI list though. And if | remove the patch supplie by Michael, | can initiate the drag, but | can't drop
anywhere (as expected, because the class names don't match up).

I'll admit to complete ignorance in a ruby environment, but what | don't understand is how this could be working for anyone if there is never a call to
decorate PBI items for dragging. Anyone have any ideas on that?

#10 - 2014-07-30 21:47 - Danny Gorton

If I'm going to figure this out I'm going to need some instruction on how the drag-n-drop is supposed to function on the Scrum board. Based on what |
see it shouldn't work at all, but | know that's not true because others have it working. So I'm missing a crucial bit. What part of the server-side code
makes the Scrum board draggable?

#11 - 2014-08-27 17:01 -Ken T
I'm having this issue as well, basically identical to Danny.
I'd be happy to donate $10 if it would expedite this patch.

#12 - 2014-08-30 14:24 - Emilio Gonzalez Montaiia

The crucial point is to reproduce this bug, I've a lot of instances of Redmine with this plugin installed, all of them working... I'm not saying it's not a
bug, | just saying | cannot help if | don't know how to reproduce it...

Could you provide more details about the environment? client & server side? (OS, version, ruby & rails version...), if I'm able | will try to reproduce it
whit those settings, unless you provide me remote access to your deployment.

#13 - 2014-08-31 05:55 - Danny Gorton

| fully understand the challenges of trying to fix issues that you cannot reproduce, | do it for a living. ;) I just wish | knew more about the Ruby
environment, or had time to learn it, I'd debug it myself. If you could kind of instruct me as to what part of the code is supposed to emit the draggable
HTML/Javascript to the client | can probably be of help. | just don't see where that is supposed to happen with the PBI items.

As for my setup, I'm running on Ubuntu 14.04 (64-bit) as a VM under VMWare ESXi. My instance is not manageable from the public address, but the
app is accessible from there, and | don't control that firewall. | do control VPN access, so if you have an OpenVPN client, or you're willing to install
one, you could be able to access it to troubleshoot that way. My plugin code has been tinkered with a little bit due to me trying to solve this issue
though.

As for clients, I've tried accessing it from Ubuntu clients running Chromium and Firefox as well as Windows clients running Chrome and Explorer. It
definitely seems to be a server-side issue, and it has to be with the conditions surrounding the code in _task.js.erb that produces the .draggable...)
javascript. | don't see that code in my rendered page for any items on the sprint board, therefore the server isn't putting it in, so that condition must be
failing (how to debug that? - <%- if User.current.allowed_to?(:edit_sprint_board, project) and task.editable? -%>). | have put the code inside that
condition OUTSIDE the condition and then my items are draggable, but it causes other issues that | don't recall right now.

Redmine environment is as follows:

Environment:

Redmine version 2.5.2.stable.13333
Ruby version 2.0.0-p481 (2014-05-08) [x86_64-linux]
Rails version 3.2.19
Environment production
Database adapter Mysql2
SCM:

Subversion 1.8.8
Mercurial 2.8.2

Git 1.9.1

Filesystem

Redmine plugins:
redmine_bootstrap_kit 0.1
redmine_ckeditor 1.0.16
redmine_custom_js_and_css  0.0.1
redmine_graphs 0.1.0
redmine_impersonate 0.0.1
redmine_issue_checklist 2.0.5
redmine_jenkins 0.1
redmine_private_wiki 0.2.2
redmine_release_notes 1.3.1
redmine_screenshot_paste 2.1.0
redmine_theme_changer 0.1.0
scrum 0.7.0
timelog_timer 2.0.0

I'll work with you in any way you want to try to figure this out. If you want to send me an email directly | can send you further contact information for
phone, IM, or whatever, whenever you want to work on it. If | can get free to help figure it out | will. As you say, there are many instances out there
working so this has to be some weird condition caused by how | installed the plugin, or how [ initially set it up, or something like that.

#14 - 2014-09-10 16:40 - Michael Kimsal

Hello Danny and others.

| maybe should clarify a bit.

For me, | can't change the position of anything on the PBI on the scrum pages. But if | create a subtask, it will be created with 'new', dropped in the

'new' column, and then | can drag that right/left as need be. but overall that's not a great workaround. | thought it was just a weird convoluted way of
structuring a project, but | think it's still just a bug.

#15 - 2014-09-14 01:46 - Francisco Bischoff
Michael Kimsal escribi6:
Hello Danny and others.
| maybe should clarify a bit.
For me, | can't change the position of anything on the PBI on the scrum pages. But if | create a subtask, it will be created with 'new', dropped in

the 'new' column, and then | can drag that right/left as need be. but overall that's not a great workaround. | thought it was just a weird
convoluted way of structuring a project, but | think it's still just a bug.

For me its like Michael said. | think it's not a bug, but a feature. Here it works fine if | create a PBI with subtasks, but took me a while to figure out.

#16 - 2014-09-18 07:23 - Danny Gorton

Ahhh...l didn't get that from my initial read of how it's supposed to work. | appreciate Michael posting his clarification and for the validation from
Francisco. | was able to do that as well after some reconfiguration of plugin settings. It just seems like a hole to me - | don't need subtasks at all and
consider the extra Issues to be clutter. But it does make a comment about the plugin by Michael Sanders make sense now: "All this plugin needs is
the ability for top-level items only." (http:/www.redmine.org/plugins/scrum-plugin). It also validates that my understanding of the code is correct - I'm
not missing anything like | thought when | considered this a bug. | still have the issue that | can't drop an item on the Scrum board, but | know that is
caused by an incorrect CSS class emitted as reported above by Michael Kimsal.

I guess I'll have to dig in and try to figure out how to make that drag-n-drop work on top-level items - | had this started before when | thought it was a
bug. It would also be nice to be able to use the Issues context menu to change the Sprint value without having to go into edit the item, so I'll have to
see if | can figure that out too.

It seems my whole complaint is based on my lack of understanding of this plugin's capabilities and for that | apologize. | still don't see anywhere in
the wiki where it describes this flow though, so | guess there's at least a beef with documentation. Thanks again everyone.

#17 - 2016-06-21 13:25 - Emilio Gonzalez Montaia
- Category set to Sprint board
- Blocked set to No

This is not a bug (maybe & only maybe a future feature).

#18 - 2016-06-21 13:25 - Emilio Gonzalez Montaina

- Status changed from New to Rejected

Files

Screenshot from redmine1.png 154 KB 2014-07-17 Danny Gorton
Screenshot from redmine2.png 136 KB 2014-07-17 Danny Gorton
redmine developer role 1.png 216 KB 2014-07-23 Danny Gorton
redmine developer role 2.png 201 KB 2014-07-23 Danny Gorton
redmine project roles.png 203 KB 2014-07-23 Danny Gorton
